package serene.simple;

import java.util.HashMap;
import serene.simple.builtin.PrintlnFn;
import serene.simple.builtin.QuitFn;


public class RootScope extends BaseScope {
  private final BaseScope parent;
  private final HashMap<String, Object> symbolsMapping = new HashMap<String, Object>() {{
      put("println", new PrintlnFn());
      put("quit", new QuitFn());
    }};
    // "+", PlusFn,
    // "-", MinusFn,
    // "*", TimesFn,
    // "/", ObelusFn,
    // "mod", ModFn,
    // "now", NowFn,


  public RootScope() {
    this.parent = null;
    System.out.println(this.symbolsMapping.get("println"));

  }

  @Override
  public Object lookupSymbol(String symbolName) {
    if (this.symbolsMapping.containsKey(symbolName)) {
      return this.symbolsMapping.get(symbolName);
    }
    else {
      throw new RuntimeException(String.format("Variable '%s' is not defined in this scope.",
                                               symbolName));
    }
  }

  public void insertSymbol(String symbolName, Object symbolValue) {
    this.symbolsMapping.put(symbolName, symbolValue);
  }
}
